package thKaguyaMod.entity;

import net.minecraft.entity.Entity;
import net.minecraft.entity.item.EntityXPOrb;
import net.minecraft.entity.monster.*;
import net.minecraft.entity.SharedMonsterAttributes;
import net.minecraft.entity.ai.EntityAIAttackOnCollide;
import net.minecraft.entity.ai.EntityAIAvoidEntity;
import net.minecraft.entity.ai.EntityAICreeperSwell;
import net.minecraft.entity.ai.EntityAIHurtByTarget;
import net.minecraft.entity.ai.EntityAILookIdle;
import net.minecraft.entity.ai.EntityAINearestAttackableTarget;
import net.minecraft.entity.ai.EntityAISwimming;
import net.minecraft.entity.ai.EntityAIWander;
import net.minecraft.entity.ai.EntityAIWatchClosest;
import net.minecraft.entity.effect.EntityLightningBolt;
import net.minecraft.entity.monster.EntityMob;
import net.minecraft.entity.monster.EntitySkeleton;
import net.minecraft.entity.passive.EntityOcelot;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.DamageSource;
import net.minecraft.util.Vec3;
import net.minecraft.world.World;
import thKaguyaMod.mod_thKaguya;
import thKaguyaMod.thKaguyaLib;
import thKaguyaMod.thShotLib;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;


public class EntityDanmakuCreeper extends EntityCreeper{
    /**
     * Time when this creeper was last in an active state (Messed up code here, probably causes creeper animation to go
     * weird)
     */
    private int lastActiveTime;

    /**
     * The amount of time since the creeper was close enough to the player to ignite
     */
    private int timeSinceIgnited;
    private int fuseTime = 30;

    /** Explosion radius for this creeper. */
    private int explosionRadius = 3;

    public EntityDanmakuCreeper(World par1World)
    {
        super(par1World);
    }

    /**
     * handles entity death timer, experience orb and particle creation
     */
    @Override
    protected void onDeathUpdate()
    {
        ++this.deathTime;

        if (this.deathTime == 40)
        {
            int i;

            if (!this.worldObj.isRemote && (this.recentlyHit > 0 || this.isPlayer()) && !this.isChild() && this.worldObj.getGameRules().getGameRuleBooleanValue("doMobLoot"))
            {
                i = this.getExperiencePoints(this.attackingPlayer);

                while (i > 0)
                {
                    int j = EntityXPOrb.getXPSplit(i);
                    i -= j;
                    this.worldObj.spawnEntityInWorld(new EntityXPOrb(this.worldObj, this.posX, this.posY, this.posZ, j));
                }
            }

            this.setDead();

            for (i = 0; i < 20; ++i)
            {
                double d0 = this.rand.nextGaussian() * 0.02D;
                double d1 = this.rand.nextGaussian() * 0.02D;
                double d2 = this.rand.nextGaussian() * 0.02D;
                this.worldObj.spawnParticle("explode", this.posX + (double)(this.rand.nextFloat() * this.width * 2.0F) - (double)this.width, this.posY + (double)(this.rand.nextFloat() * this.height), this.posZ + (double)(this.rand.nextFloat() * this.width * 2.0F) - (double)this.width, d0, d1, d2);
            }
        }
    }
    
    /**
     * Called to update the entity's position/logic.
     */
    @Override
    public void onUpdate()
    {
    	boolean danmakuFlag = false;
    	
    	/*if(ticksExisted % 30 == 0)
    	{
    		Vec3 vec3 = thShotLib.getVecFromAngle(rotationYaw, rotationPitch, 1.0D);
    		thKaguyaLib.createHomingAmulet(worldObj, this, this, this.posX, this.posY, this.posZ, vec3.xCoord , vec3.yCoord, vec3.zCoord, 0.6D, 0.6D, 0.0D, 0.0D, 0.0D, 0.0D, 2.0F, 0, 0.4F, 120, 5);
    	}*/
    	
        if (this.isEntityAlive())
        {
            this.lastActiveTime = this.timeSinceIgnited;
            int i = this.getCreeperState();

            if (i > 0 && this.timeSinceIgnited == 0)
            {
                this.playSound("random.fuse", 1.0F, 0.5F);
            }

            this.timeSinceIgnited += i;

            if (this.timeSinceIgnited < 0)
            {
                this.timeSinceIgnited = 0;
            }

            if (this.timeSinceIgnited >= this.fuseTime)
            {
                this.timeSinceIgnited = 0;//this.fuseTime;

                if (!this.worldObj.isRemote)
                {
                    boolean flag = this.worldObj.getGameRules().getGameRuleBooleanValue("mobGriefing");
                    float damage = 5.0F;//3 + this.worldObj.difficultySetting * 2;
                    int level = mod_thKaguya.danmakuLevel;
                    float size = 0.1F + level * 0.1F;
                    int way = 40 + level * 8;
                    if(way > 72)
                    {
                    	way = 72;
                    }
                    int way2 = way * 2;

                    if (this.getPowered())
                    {
                        for(i = 0; i < way2 ; i++)
                        {
                        	thShotLib.createShot(this, this, posX, posY, posZ, rand.nextFloat() * 360F, rand.nextFloat() * 180F - 90F, 0F, 0.0D, 1.0D, 0.0D, 1.2D, 0.01D, -0.00D, 0.0D, -0.02D, 0.0D, damage * 2F, thShotLib.LIGHT[thShotLib.GREEN], size, 120, 0, 0);
                        	thShotLib.createShot(this, this, posX, posY, posZ, rand.nextFloat() * 360F, rand.nextFloat() * 180F - 90F, 0F, 0.0D, 1.0D, 0.0D, 0.5D, 0.01D, -0.00D, 0.0D, -0.02D, 0.0D, damage * 2F, thShotLib.LIGHT[thShotLib.RED],size, 120, 0, 0);
                        	thShotLib.createShot(this, this, posX, posY, posZ, rand.nextFloat() * 360F, rand.nextFloat() * 180F - 90F, 0F, 0.0D, 1.0D, 0.0D, 0.4D, 0.01D, -0.00D, 0.0D, -0.02D, 0.0D, damage * 2F, thShotLib.LIGHT[thShotLib.YELLOW], size, 120, 0, 0);
                        }
                        //this.worldObj.createExplosion(this, this.posX, this.posY, this.posZ, (float)this.explosionRadius, flag);
                    }
                    else
                    {
                        for(i = 0; i < way ; i++)
                        {
                        	thShotLib.createShot(this, this, posX, posY, posZ, rand.nextFloat() * 360F, rand.nextFloat() * 180F - 90F, 0F, 0.0D, 1.0D, 0.0D, 0.6D, 0.01D, -0.00D, 0.0D, -0.02D, 0.0D, damage, thShotLib.LIGHT[thShotLib.GREEN], size, 120, 0, 0);
                        	thShotLib.createShot(this, this, posX, posY, posZ, rand.nextFloat() * 360F, rand.nextFloat() * 180F - 90F, 0F, 0.0D, 1.0D, 0.0D, 0.5D, 0.01D, -0.00D, 0.0D, -0.02D, 0.0D, damage, thShotLib.LIGHT[thShotLib.RED],size, 120, 0, 0);
                        	thShotLib.createShot(this, this, posX, posY, posZ, rand.nextFloat() * 360F, rand.nextFloat() * 180F - 90F, 0F, 0.0D, 1.0D, 0.0D, 0.4D, 0.01D, -0.00D, 0.0D, -0.02D, 0.0D, damage, thShotLib.LIGHT[thShotLib.YELLOW], size, 120, 0, 0);
                        }
                        //this.worldObj.createExplosion(this, this.posX, this.posY, this.posZ, (float)this.explosionRadius, flag);
                    }
                    this.worldObj.playSoundEffect(this.posX, this.posY, this.posZ, "random.explode", 4.0F, (1.0F + (this.worldObj.rand.nextFloat() - this.worldObj.rand.nextFloat()) * 0.2F) * 0.7F);


                    //this.setDead();
                }
                //timeSinceIgnited = 0;
                setCreeperState(0);
                danmakuFlag = true;
                setEntityHealth(0.0F);
            }
        }
        
        if(!danmakuFlag)
        {
        	super.onUpdate();
        }
    }

    /**
     * Called when the mob's health reaches 0.
     */
    public void onDeath(DamageSource par1DamageSource)
    {
        super.onDeath(par1DamageSource);

        if (par1DamageSource.getEntity() instanceof EntitySkeleton)
        {
            int i = Item.record13.itemID + this.rand.nextInt(Item.recordWait.itemID - Item.record13.itemID + 1);
            this.dropItem(i, 1);
        }
    }
    

    /**
     * Returns the item ID for the item the mob drops on death.
     */
    protected int getDropItemId()
    {
        return Item.gunpowder.itemID;
    }
}
